#include <catch2/catch_all.hpp>
#include <thrust/device_vector.h>
#include <thrust/host_vector.h>

#include <vector>
#include <limits>
#include <cstdlib>

TEST_CASE("CUDA test", "[cuda]")
{
    using real_t = double;
    constexpr int size = 10;
    constexpr auto eps = std::numeric_limits<real_t>::epsilon() * 10;
    std::vector<real_t> v(size);
    std::generate(v.begin(), v.end(), []() { return rand(); } );

    thrust::device_vector<real_t> dv(v.begin(), v.end());
    thrust::host_vector<real_t> hv = dv;

    for(int i=0; i<size; ++i)
    {
        CHECK(hv[i] == Catch::Approx(v[i]).epsilon(eps));
    }
}
